package crawler_manager

import (


	g "loafle.com/overflow/crawler_go/grpc"

	"loafle.com/overflow/crawler_go/config"

	"encoding/json"

	"io/ioutil"

)

const (
	address = "localhost:"
	defaultPort = 50001
)

var currentPort = defaultPort

var pidMap map[string]int

var exeMap map[string]string

var portMap map[string]string

func init() {

	pidMap = make(map[string]int)
	exeMap = make(map[string]string)
	portMap = make(map[string]string)

	//pidMap["HEALTH_REDIS"] = 18281

	exeMap[g.Crawlers_HEALTH_REDIS.String()] = "/home/snoop/develop/path/go/src/loafle.com/overflow/tnc";

}

func ReadConfig(path string ) *config.Config {

	bytes, err := ioutil.ReadFile(path)

	if err != nil {
		return nil
	}

	c := config.Config{}

	json.Unmarshal(bytes, &c)

	return &c


}

func ManageCrawler(path string) {

	c := ReadConfig(path)

	exePath := exeMap[c.Crawler.Name]

	cs := c.Crawler.Name

	pid := pidMap[cs]

	if pid > 0 {
		b := IsAlive(pid)
		if b == false {
			ExeCrawler(c, exePath)
			CallInit(c, path)
		} else {
			CallAdd()
		}


	} else {
		ExeCrawler(c, exePath)
		CallInit(c, path)
	}

}
